This doc introduce the usage of CovenantSQL mysql adapter. 
This adapter lets you use CovenantSQL with any unmodified mysql client.

## Prerequisites

Make sure the ```$GOPATH/bin``` is in your ```$PATH```, download build the mysql adapter binary.

```shell
$ go get github.com/CovenantSQL/CovenantSQL/cmd/cql-mysql-adapter
```

Adapter requires a CovenantSQL ```config.yaml``` which can by generated by configuration generator.  

### Generating Default Config File

Generate the main configuration file. Same as [Generating Default Config File in Golang Client Doc](https://github.com/CovenantSQL/CovenantSQL/tree/develop/client#generating-default-config-file). An existing configuration file can also be used.

## MySQL Adapter Usage

### Start

Start the mysql adapter by following commands:

```shell
$ cql-mysql-adapter -config config.yaml
```

The default mysql user is ```root``` and the default mysql password is ```calvin```, which can be modified as optional arguments of mysql adapter.
The default listen address of the adapter is ```127.0.0.1:4664```, which can also be modified using command-line argument.

Avaiable command-line arguments are: 

```shell
$ cql-mysql-adapter --help
Usage of ./cql-mysql-adapter:
  -bypassSignature
    	Disable signature sign and verify, for testing
  -config string
    	config file for mysql adapter (default "./config.yaml")
  -listen string
    	listen address for mysql adapter (default "127.0.0.1:4664")
  -mysql-password string
    	mysql password for adapter server (default "calvin")
  -mysql-user string
    	mysql user for adapter server (default "root")
  -password string
    	master key password
```

### Use the adapter

Connect the mysql adapter using the command-line client:

```shell
$ mysql -u root -h 127.0.0.1 -P 4664 -p calvin
Warning: Using a password on the command line interface can be insecure.
Welcome to the MySQL monitor.  Commands end with ; or \g.
Your MySQL connection id is 10003
Server version: 5.7.0

Copyright (c) 2000, 2018, Oracle and/or its affiliates. All rights reserved.

Oracle is a registered trademark of Oracle Corporation and/or its
affiliates. Other names may be trademarks of their respective
owners.

Type 'help;' or '\h' for help. Type '\c' to clear the current input statement.

mysql> use 057e55460f501ad071383c95f691293f2f0a7895988e22593669ceeb52a6452a

Reading table information for completion of table and column names
You can turn off this feature to get a quicker startup with -A

Database changed
mysql> show tables;
+----------------+
| name           |
+----------------+
| TEST           |
+----------------+
1 rows in set (0.11 sec)

mysql> quit
Bye
```